package training.ant.task;

import java.io.File;
import java.util.Date;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

public class FileStatTask extends Task {
  private File file;

  public void execute() throws BuildException {
    System.out.println("    file: " + file.getAbsolutePath());
    System.out.println("  length: " + file.length() + " bytes");
    System.out.println("readable: " + file.canRead());
    System.out.println("writable: " + file.canWrite());
    System.out.println("modified: " + new Date(file.lastModified()));
  }

  public void setFile(String fileName) {
    file = new File(fileName);
  }
}
