package local;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;
import java.io.*;
import java.net.*;
import java.util.jar.*;
import java.util.zip.*;

import remote.Command;
import remote.CommandException;

public class RemoteCopyTask extends RemoteTask
{
	private String _sFilename = null;
	private String _sDirectory = null;
	private String _sFiletype = null;

	private String _sFullFilename = null;

	private String _sOutputText = null;
	private byte[] _bytes = null;

	public void setCommand() throws IOException
	{
		try
		{
			_command = new Command( Command.COPY, _sFiletype, _sDirectory, _sFilename);
		}
		catch (CommandException ce)
		{
			throw new IOException( ce.getMessage() );
		}

		// read file into buffer
		_sFullFilename = _sDirectory +"/"+ _sFilename;
	}

	// The setter for the "filename" attribute
	public void setFilename(String filename)
	{
		_sFilename = filename;
	}

	// The setter for the "directory" attribute
	public void setDirectory(String directory)
	{
		_sDirectory = directory;
	}

	// The setter for the "fileType" attribute
	public void setFiletype(String fileType)
	{
		_sFiletype = fileType;
	}
}