/*
Ex 6c: Compte-Rendu de TP  rendre par mail  didier.donsez@imag.fr

Dveloppement dune tche ANT

SlideshowTask gnre un diaporama  partir des photos se trouvant dans un rpertoire.
Le diaporama est constitu dune page dindex HTML contenant les vignettes (thumbnail)
des photos et dune page diapo HTML par photo contenant la photo et une barre de navigation.
La barre de navigation permet de passer  la suivante, revenir  la prcdente et de remonter
 lindex.
Les attributs de la tche sont :
	dir: le rpertoire dans lequel sont les photos et dans lequel les pages HTML sont gnres.
	maxdim: la hauteur ou largeur maximale des vignettes qui sont places par dfaut dans le sous rpertoire .thumbnail du rpertoire dsign par lattribut dir
	cols: le nombre de vignettes affiches (en largeur) dans la page dindex
	timer: le dlai de passage dune diapo  une autre dans les documents diapo.
	circular: drapeau indiquant si la transition de la dernire photo revient sur la premire.

Par exemple, lexcution de la tche suivante sur un rpertoire contenant 4 photos : im1.jpg, im2.jpg, im3.jpg, im4.jpg
  <slideshow dir="${img.dir} " maxdim="128" cols="3" timer="20" circular="yes"/>

gnre la page dindex suivante et des pages de diapo similaire  la diapo3.htm

index.htm
---------
<HTML>
<HEAD>
<TITLE>Diaporama</TITLE>
</HEAD>
<BODY>
<CENTER>
<H1>Diaporama</H1>
<TABLE COLS="3">
<TR>
<TD><A HREF="diapo0.htm"><IMG SRC=".thumbnail/im1.jpg"></A></TD>
<TD><A HREF="diapo1.htm"><IMG SRC=".thumbnail/im2.jpg"></A></TD>
<TD><A HREF="diapo2.htm"><IMG SRC=".thumbnail/im3.jpg"></A></TD>
</TR>
<TR>
<TD><A HREF="diapo3.htm"><IMG SRC=".thumbnail/im4.jpg"></A></TD>
<TD></TD>
<TD></TD>
</TR>
</CENTER>
</BODY>
</HTML>

diapo3.htm
----------
<HTML>
<HEAD>
<TITLE>Diapo 3</TITLE>
<!-- Timer -->
<META HTTP-EQUIV="Refresh" CONTENT="20; URL=diapo0.htm">
</HEAD>
<BODY>
<CENTER>
<!-- Nav bar -->
<A HREF="diapo2.htm">&lt;&lt;</A>
&nbsp;[<A HREF="index.htm">Top</A>]&nbsp;
<A HREF="diapo3.htm">&gt;&gt;</A>
<BR>
<!-- Photo -->
<IMG SRC="im4.jpg">
</CENTER>
</BODY>
</HTML>

(En Option) Dans une seconde version, utilisez directement la classe ThumbnailizeTask
pour gnrer les vignettes lors de l'appel de la mthode execute() de la classe SlideshowTask.


*/

package training.ant.task;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.FileOutputStream;
import java.io.File;
import java.io.FilenameFilter;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

public class SlideshowTask extends Task {

	static boolean DEBUG=true;
	
	static void trace(String msg){
		if(DEBUG) System.out.println(msg);
	}

	private String dir;
	private int maxdim=128;
	private int cols=6;
	private int timer=Integer.MAX_VALUE; // set timer to infinity
	private boolean circular=false; // return to the index for the last transition
	
	public void execute() throws BuildException {
		// TODO !!
	}

    /**
     * Sets the maximum width or heigth of each thumbnail.
     */
	public void setMaxdim(int maxdim) {
		this.maxdim = maxdim;
	}
	
    /**
     * Sets the number of colunms in the index.
     */
	public void setCols(int cols) {
		this.cols = cols;
	}

    /**
     * Sets the delay between transition.
     */
	public void setTimer(int timer) {
		this.timer = timer;
	}

    /**
     * Sets the flag to set the last slide' transition to the first slide.
     */
	public void setCircular(boolean circular) {
		this.circular = circular;
	}

    /**
     * Sets a directory to generate the slideshow.
     */
	public void setDir(String dirName) {
		this.dir = dirName;
	}
	
}

class ImageFilenameFilter implements FilenameFilter {
	public boolean accept(File dir, String name) {
		if(
		        name.indexOf(".gif")!=-1 || name.indexOf(".jpg")!=-1 || name.indexOf(".jpeg")!=-1
		        || name.indexOf(".GIF")!=-1 || name.indexOf(".JPG")!=-1 || name.indexOf(".JPEG")!=-1
		) {
			return true;
		} else {
			return false;
		}
	}
}
