package remote;

import java.io.*;

public class RunProcess
{
	private String _sCommand = null;
	private String[] _sArrayArgs = null;

	public RunProcess(String sCommand, String[] args)
	{
		_sCommand = sCommand;
		_sArrayArgs = args;
	}

	private String convertArgsToString(String[] args)
	{
		String command = " ";

		for ( int i = 0; i < args.length; i++)
		{
			command += args[i];
			command += " ";
		}

		return command;
	}

	public void run() throws IOException
	{
		String sArgs = convertArgsToString( _sArrayArgs);

		String sFullCommand = _sCommand +" "+ sArgs;

		Runtime runtime = Runtime.getRuntime();

		Process process = runtime.exec( sFullCommand );

		BufferedReader buf = new BufferedReader( new InputStreamReader( process.getInputStream() ));
		String line = null;
		while ( (line=buf.readLine()) != null)
		{
			System.out.println(line);
		}
	}
}